#[doc = "Register `MEM_DATA501` reader"]
pub struct R(crate::R<MEM_DATA501_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<MEM_DATA501_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<MEM_DATA501_SPEC>> for R {
    fn from(reader: crate::R<MEM_DATA501_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `MEM_DATA501` writer"]
pub struct W(crate::W<MEM_DATA501_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<MEM_DATA501_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<MEM_DATA501_SPEC>> for W {
    fn from(writer: crate::W<MEM_DATA501_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `DR` reader - Data Register for EP ; This register is linked to the memory, hence reset value is undefined"]
pub struct DR_R(crate::FieldReader<u8, u8>);
impl DR_R {
    pub(crate) fn new(bits: u8) -> Self {
        DR_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for DR_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `DR` writer - Data Register for EP ; This register is linked to the memory, hence reset value is undefined"]
pub struct DR_W<'a> {
    w: &'a mut W,
}
impl<'a> DR_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xff) | (value as u32 & 0xff);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:7 - Data Register for EP ; This register is linked to the memory, hence reset value is undefined"]
    #[inline(always)]
    pub fn dr(&self) -> DR_R {
        DR_R::new((self.bits & 0xff) as u8)
    }
}
impl W {
    #[doc = "Bits 0:7 - Data Register for EP ; This register is linked to the memory, hence reset value is undefined"]
    #[inline(always)]
    pub fn dr(&mut self) -> DR_W {
        DR_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "DATA\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [mem_data501](index.html) module"]
pub struct MEM_DATA501_SPEC;
impl crate::RegisterSpec for MEM_DATA501_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [mem_data501::R](R) reader structure"]
impl crate::Readable for MEM_DATA501_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [mem_data501::W](W) writer structure"]
impl crate::Writable for MEM_DATA501_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets MEM_DATA501 to value 0"]
impl crate::Resettable for MEM_DATA501_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
